Index: /trunk/sources/HeuristicLab.Services.Deployment/3.3/Admin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.Deployment/3.3/Admin.cs	(revision 4272)
+++ /trunk/sources/HeuristicLab.Services.Deployment/3.3/Admin.cs	(revision 4273)
@@ -20,11 +20,4 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Runtime.Serialization;
-using System.ServiceModel;
-using System.Text;
-using HeuristicLab.Services.Deployment.DataAccess;
 using System.Security.Permissions;
 
@@ -32,15 +25,15 @@
   public class Admin : IAdmin {
     #region IAdmin Members
-    [PrincipalPermission(SecurityAction.Demand, Role = "Managers")]
+    [PrincipalPermission(SecurityAction.Demand, Role = "Deployment Administrator")]
     public void DeployProduct(ProductDescription product) {
       var store = new PluginStore();
       store.Persist(product);
     }
-    [PrincipalPermission(SecurityAction.Demand, Role = "Managers")]
+    [PrincipalPermission(SecurityAction.Demand, Role = "Deployment Administrator")]
     public void DeleteProduct(ProductDescription product) {
       var store = new PluginStore();
       store.Delete(product);
     }
-    [PrincipalPermission(SecurityAction.Demand, Role = "Managers")]
+    [PrincipalPermission(SecurityAction.Demand, Role = "Deployment Administrator")]
     public void DeployPlugin(PluginDescription plugin, byte[] zipFile) {
       var store = new PluginStore();
Index: /trunk/sources/HeuristicLab.Services.Deployment/3.3/App.config
===================================================================
--- /trunk/sources/HeuristicLab.Services.Deployment/3.3/App.config	(revision 4272)
+++ /trunk/sources/HeuristicLab.Services.Deployment/3.3/App.config	(revision 4273)
@@ -29,10 +29,10 @@
     </sources>
     <sharedListeners>
-      <add initializeData="C:\inetpub\wwwroot\Deployment-3.3\web_messages.svclog"
+      <add initializeData="C:\inetpub\wwwroot\services.heuristiclab.com\Deployment-3.3\web_messages.svclog"
         type="System.Diagnostics.XmlWriterTraceListener, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089"
         name="ServiceModelMessageLoggingListener" traceOutputOptions="Timestamp">
         <filter type="" />
       </add>
-      <add initializeData="C:\inetpub\wwwroot\Deployment-3.3\web_tracelog.svclog"
+      <add initializeData="C:\inetpub\wwwroot\services.heuristiclab.com\Deployment-3.3\web_tracelog.svclog"
         type="System.Diagnostics.XmlWriterTraceListener, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089"
         name="ServiceModelTraceListener" traceOutputOptions="Timestamp">
@@ -44,5 +44,5 @@
     <remove name="LocalSqlServer" />
     <add connectionString="Server=SERVICES;Database=HeuristicLab.Deployment;Integrated Security=SSPI" name="HeuristicLab.Services.Deployment.DataAccess.Properties.Settings.HeuristicLab_PluginStoreConnectionString" />
-    <add name="MyLocalSQLServer" connectionString="Initial Catalog=aspnetdb;data source=localhost;Integrated Security=SSPI;" />
+    <add name="HeuristicLab.Authentication" connectionString="Initial Catalog=HeuristicLab.Authentication;data source=localhost;Integrated Security=SSPI;" />
   </connectionStrings>
   <system.webServer>
@@ -56,15 +56,15 @@
     <compilation debug="false" />
     <httpRuntime maxRequestLength="2097151" />
-    <membership defaultProvider="MySqlMembershipProvider">
+    <membership defaultProvider="AspNetSqlMembershipProvider">
       <providers>
         <clear />
-        <add name="MySqlMemberShipProvider" type="System.Web.Security.SqlMembershipProvider, System.Web, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" connectionStringName="MyLocalSqlServer" enablePasswordReset="false" enablePasswordRetrieval="false" passwordFormat="Hashed" requiresQuestionAndAnswer="false" requiresUniqueEmail="false"  minRequiredNonalphanumericCharacters="0" minRequiredPasswordLength="8" />
+        <add name="AspNetSqlMemberShipProvider" type="System.Web.Security.SqlMembershipProvider, System.Web, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" connectionStringName="HeuristicLab.Authentication" applicationName="HeuristicLab.Authentication" enablePasswordReset="false" enablePasswordRetrieval="false" passwordFormat="Hashed" requiresQuestionAndAnswer="false" requiresUniqueEmail="false"  minRequiredNonalphanumericCharacters="0" minRequiredPasswordLength="8" />
       </providers>
     </membership>
     <authentication mode="Windows" />
-    <roleManager enabled="true" defaultProvider="MySqlRoleProvider">
+    <roleManager enabled="true" defaultProvider="AspNetSqlRoleProvider">
       <providers>
         <clear />
-        <add name="MySqlRoleProvider" connectionStringName="MyLocalSQLServer" applicationName="HeuristicLab.Deployment" type="System.Web.Security.SqlRoleProvider, System.Web, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+        <add name="AspNetSqlRoleProvider" connectionStringName="HeuristicLab.Authentication" applicationName="HeuristicLab.Authentication" type="System.Web.Security.SqlRoleProvider, System.Web, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
       </providers>
     </roleManager>
@@ -122,8 +122,8 @@
              storeName="My" x509FindType="FindBySubjectName" />
             <userNameAuthentication userNamePasswordValidationMode="MembershipProvider"
-             membershipProviderName="MySqlMembershipProvider" />
+             membershipProviderName="AspNetSqlMembershipProvider" />
           </serviceCredentials>
           <serviceAuthorization principalPermissionMode="UseAspNetRoles"
-           roleProviderName="MySqlRoleProvider" />
+           roleProviderName="AspNetSqlRoleProvider" />
         </behavior>
         <behavior name="HeuristicLab.Services.Deployment.AdminBehavior">
@@ -134,8 +134,8 @@
              storeName="My" x509FindType="FindBySubjectName" />
             <userNameAuthentication userNamePasswordValidationMode="MembershipProvider"
-             membershipProviderName="MySqlMembershipProvider" />
+             membershipProviderName="AspNetSqlMembershipProvider" />
           </serviceCredentials>
           <serviceAuthorization principalPermissionMode="UseAspNetRoles"
-           roleProviderName="MySqlRoleProvider" />
+           roleProviderName="AspNetSqlRoleProvider" />
         </behavior>
       </serviceBehaviors>