Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Moves/IntraRouteInversion/IntraRouteInversionMove.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Moves/IntraRouteInversion/IntraRouteInversionMove.cs	(revision 4287)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Moves/IntraRouteInversion/IntraRouteInversionMove.cs	(revision 4288)
@@ -72,5 +72,5 @@
     }
 
-    public IVRPEncoding MakeMove(IRandom random) {
+    public IVRPEncoding MakeMove() {
       IntraRouteInversionMoveMaker.Apply(Individual as AlbaEncoding, this);
 
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Moves/IntraRouteInversion/IntraRouteInversionMoveMaker.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Moves/IntraRouteInversion/IntraRouteInversionMoveMaker.cs	(revision 4287)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Moves/IntraRouteInversion/IntraRouteInversionMoveMaker.cs	(revision 4288)
@@ -61,6 +61,4 @@
       IOperation next = base.Apply();
       
-      AlbaEncoding solution = VRPToursParameter.ActualValue as AlbaEncoding;
-
       IntraRouteInversionMove move = IntraRouteInversionMoveParameter.ActualValue;
       DoubleValue moveQuality = MoveQualityParameter.ActualValue;
@@ -68,5 +66,5 @@
      
       //perform move
-      Apply(solution, move);
+      VRPToursParameter.ActualValue = move.MakeMove();
 
       quality.Value = moveQuality.Value;
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Moves/LambdaInterchange/LambdaInterchangeMove.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Moves/LambdaInterchange/LambdaInterchangeMove.cs	(revision 4287)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Moves/LambdaInterchange/LambdaInterchangeMove.cs	(revision 4288)
@@ -111,5 +111,5 @@
     }
 
-    public IVRPEncoding MakeMove(IRandom random) {
+    public IVRPEncoding MakeMove() {
       LambdaInterchangeMoveMaker.Apply(Individual as AlbaEncoding, this);
 
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Moves/LambdaInterchange/LambdaInterchangeMoveMaker.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Moves/LambdaInterchange/LambdaInterchangeMoveMaker.cs	(revision 4287)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Alba/Moves/LambdaInterchange/LambdaInterchangeMoveMaker.cs	(revision 4288)
@@ -65,6 +65,4 @@
       IOperation next = base.Apply();
       
-      AlbaEncoding solution = VRPToursParameter.ActualValue as AlbaEncoding;
-
       LambdaInterchangeMove move = LambdaInterchangeMoveParameter.ActualValue;
       DoubleValue moveQuality = MoveQualityParameter.ActualValue;
@@ -72,5 +70,5 @@
      
       //perform move
-      Apply(solution, move);
+      VRPToursParameter.ActualValue = move.MakeMove();
 
       quality.Value = moveQuality.Value;
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/General/Moves/Interfaces/IVRPMove.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/General/Moves/Interfaces/IVRPMove.cs	(revision 4287)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/General/Moves/Interfaces/IVRPMove.cs	(revision 4288)
@@ -34,5 +34,5 @@
       ILookupParameter<DoubleMatrix> distanceMatrix, BoolValue useDistanceMatrix);
 
-    IVRPEncoding MakeMove(IRandom random);
+    IVRPEncoding MakeMove();
   }
 }
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/General/Moves/MultiVRPMoveOperator/MultiVRPMoveMaker.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/General/Moves/MultiVRPMoveOperator/MultiVRPMoveMaker.cs	(revision 4287)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/General/Moves/MultiVRPMoveOperator/MultiVRPMoveMaker.cs	(revision 4288)
@@ -114,5 +114,5 @@
      
       //perform move
-      VRPToursParameter.ActualValue = move.MakeMove(RandomParameter.ActualValue);
+      VRPToursParameter.ActualValue = move.MakeMove();
 
       quality.Value = moveQuality.Value;